package entity;

import java.util.List;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OrderColumn;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;


@Entity
@Access(AccessType.FIELD)
@Table(uniqueConstraints=@UniqueConstraint(columnNames={"NICKNAME", "UID"}))
public class Inventory {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	long id;
	
	@Column(nullable=false)
	int uid;
	
	@Column(nullable=false)
	int nickname;

	@Column(length=30)
	String deviceBarCode;
	
	int deviceCoordinates;
	
	@Column(columnDefinition="INTEGER DEFAULT -1")
	int lastFeeder;
	
	char lastPhase;
	
	long lastReport;
	
	long lastChanged;
	
	long lastMissed;
	
	long lastAlert;
	
	@Column(length=1024)
	String caption;
	
	@Column(length=10)
	String state;
	
	@Column(length=40)
	String installerEmail;
	
    @ManyToOne
    @JoinColumn(name="OBJECTTABLE_ID", nullable=false)
	ObjectTable objectTable;
    
	@OneToMany(cascade=CascadeType.ALL, mappedBy="inv")
	@OrderColumn(name="id")
	List<Reports> reports;

	public int getNickname() {
		return nickname;
	}

	public void setNickname(int nickname) {
		this.nickname = nickname;
	}

	public String getDeviceBarCode() {
		return deviceBarCode;
	}

	public void setDeviceBarCode(String deviceBarCode) {
		this.deviceBarCode = deviceBarCode;
	}

	public int getDeviceCoordinates() {
		return deviceCoordinates;
	}

	public void setDeviceCoordinates(int deviceCoordinates) {
		this.deviceCoordinates = deviceCoordinates;
	}

	public int getLastFeeder() {
		return lastFeeder;
	}

	public void setLastFeeder(int lastFeeder) {
		this.lastFeeder = lastFeeder;
	}

	public char getLastPhase() {
		return lastPhase;
	}

	public void setLastPhase(char lastPhase) {
		this.lastPhase = lastPhase;
	}

	public long getLastReport() {
		return lastReport;
	}

	public void setLastReport(long lastReport) {
		this.lastReport = lastReport;
	}

	public long getLastChanged() {
		return lastChanged;
	}

	public void setLastChanged(long lastChanged) {
		this.lastChanged = lastChanged;
	}

	public long getLastMissed() {
		return lastMissed;
	}

	public void setLastMissed(long lastMissed) {
		this.lastMissed = lastMissed;
	}

	public long getLastAlert() {
		return lastAlert;
	}

	public void setLastAlert(long lastAlert) {
		this.lastAlert = lastAlert;
	}

	public String getCaption() {
		return caption;
	}

	public void setCaption(String caption) {
		this.caption = caption;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getInstallerEmail() {
		return installerEmail;
	}

	public void setInstallerEmail(String installerEmail) {
		this.installerEmail = installerEmail;
	}

	public ObjectTable getObjectTable() {
		return objectTable;
	}

	public void setObjectTable(ObjectTable objectTable) {
		this.objectTable = objectTable;
	}

	public List<Reports> getReports() {
		return reports;
	}

	public void setReports(List<Reports> reports) {
		this.reports = reports;
	}

	public int getUid() {
		return uid;
	}

	public void setUid(int uid) {
		this.uid = uid;
	}

	public long getId() {
		return id;
	}

	
}
