package entity;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;


@Entity
@Access(AccessType.FIELD)
public class Reports {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	long id;

	long received;
	
	@Column(columnDefinition="INTEGER DEFAULT -1")
	int feeder;
	
	char phase;
	
	int channelId;

	@Column(length=510)
	String payload;

	long fimSequenceNumber;
	
    @ManyToOne
    @JoinColumn(name="INVENTORY_ID", nullable=false)
    Inventory inv;
    
	@OneToOne(optional=false, mappedBy="report", cascade=CascadeType.ALL)
	ReportQuality msgQuality;

	public long getReceived() {
		return received;
	}

	public void setReceived(long received) {
		this.received = received;
	}

	public int getFeeder() {
		return feeder;
	}

	public void setFeeder(int feeder) {
		this.feeder = feeder;
	}

	public char getPhase() {
		return phase;
	}

	public void setPhase(char phase) {
		this.phase = phase;
	}

	public int getChannelId() {
		return channelId;
	}

	public void setChannelId(int channelId) {
		this.channelId = channelId;
	}

	public String getPayload() {
		return payload;
	}

	public void setPayload(String payload) {
		this.payload = payload;
	}

	public long getFimSequenceNumber() {
		return fimSequenceNumber;
	}

	public void setFimSequenceNumber(long fimSequenceNumber) {
		this.fimSequenceNumber = fimSequenceNumber;
	}

	public Inventory getInv() {
		return inv;
	}

	public void setInv(Inventory inv) {
		this.inv = inv;
	}

	public ReportQuality getMsgQuality() {
		return msgQuality;
	}

	public void setMsgQuality(ReportQuality msgQuality) {
		this.msgQuality = msgQuality;
	}

	public long getId() {
		return id;
	}


}
